module BabelI18n
  class Base

    attr_accessor :translation

    def initialize(text, key, &block)
      @translation = BabelI18n::Translate.new(text)
      @translation.instance_eval(&block) if block_given?
      @translation.key = key
    end

    def translate
      @translation.translate
    end

    def to(to)
      @translation.to(to)
      self
    end

    def from(from)
      @translation.from(from)
      self
    end

  end
end
