require 'google/api'
module BabelI18n

  class Translate

    include Google::API

    attr_accessor :text, :key

    def initialize(text)
      @text = text
      @from, @to = nil, nil
    end

    def from(from)
      @from = from
    end

    def to(to)
      @to = to
    end

    def target
      @to
    end

    def source
      @from
    end

    def translate
      valid? ? google_translate : 'Error when translating'
    end

    def valid?
      (!@text.nil? && !@text.empty?) && !@to.nil?
    end

  end
end
